// screen3.c - Third MTXLib demonstration screen

#include <stdio.h>
#include <diskio.h>
#include <mtxscrn.h>

void Dump (void *data, unsigned int len)
    {
    unsigned char *pdata = (unsigned char *) data;
    while ( len > 0 )
        {
        printf ("%04X", pdata);
        int n = len;
        if ( n > 8 ) n = 8;
        for (int i = 0; i < n; ++i)
            printf (" %02X", pdata[i]);
        for (int i = n; i < 8; ++i)
            printf ("   ");
        printf ("  ");
        for (int i = 0; i < n; ++i)
            {
            unsigned char ch = pdata[i];
            if (( ch < 0x20 ) || ( ch > 0x7E )) ch = '.';
            printf ("%c", ch);
            }
        printf ("\r\n");
        pdata += n;
        len -= n;
        }
    }

void screen3 (void)
    {
    FCB fcb;
    unsigned char buf[128];
    vs (5);
    printf ("Dir *.*\r\n");
    unsigned char *pdir = findfirst (&fcb, buf, "*.*");
    while ( pdir != NULL )
        {
        Dump (buf, 12);
        pdir = findnext ();
        }
    printf ("Screen 3\r\n");
    }
