// screen7.c - Interrupts demo

#include <stdio.h>
#include <mtxscrn.h>
#include <mtxvdp.h>
#include <mtxint.h>

void Counter (void)
    {
    char *units = (char *) 0xFD5C;
    char *tens = (char *) 0xFD5B;
    while ( inkey () == 0 )
        {
        printf (" %c%c\r", *tens, *units);
        pause (125);
        }
    printf ("\n");
    }

static unsigned char iClr = 0;
static unsigned char iCnt = 0;

void Cycle (void)
    {
    if ( ++iCnt >= 10 )
        {
        ++iClr;
        vdpreg (7, iClr);
        iCnt = 0;
        }
    }

void screen7 (void)
    {
    vs (5);
    ink (15);
    paper (4);
    cls ();
    vdpmode (1, 0, 1);      // Text mode with VDP interrupts
    printf ("Hold any key to stop\r\nRelease to continue\r\nMTX BASIC Interrupt\r\n");
    Counter ();
    printf ("Stopped\r\n");
    while ( inkey () != 0 );
    printf ("VDP Interrupt - Slower\r\n");
    vdpmode (1, 0, 1);      // Text mode with VDP interrupts
    intvdp ();
    Counter ();
    printf ("Stopped\r\n");
    while ( inkey () != 0 );
    printf ("CTC Callback - Clock Stopped\r\nVDP Int Cycles Colours\r\n");
    ctccb (0, Cycle);
    Counter ();
    int125 ();
    printf ("Stopped\r\n");
    while ( inkey () != 0 );
    vs (5);
    printf ("Screen 7");
    }
